﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Shapes;
using System.Windows.Media.Animation;

namespace WebScreenSaver
{
    /// <summary>
    /// Interaction logic for Overlay.xaml
    /// </summary>
    public partial class Overlay : Window
    {

        int _monitorNumber = 0;
        double _left, _top, _width, _height;

        


        public Overlay(int monitorNumber, double left, double top, double width, double height)
        {
            InitializeComponent();

            // setup private vars
            _monitorNumber = monitorNumber;
            _left = left;
            _top = top;
            _width = width;
            _height = height;

            SetupAndDisplayWindow();

        }

#region Display Window



        private void SetupAndDisplayWindow() { 
        
                 //setup window
            this.Name = String.Format("WebScreenSaverOverlay{0}",_monitorNumber);
            this.Title = String.Format("WebScreenSaverOverlay{0}", _monitorNumber);

            // setup window for display
            this.Left = _left;
            this.Top = _top;
            this.Width = _width;
            this.Height = _height;
            this.WindowStyle = WindowStyle.None;


        }

        private void Window_Loaded(object sender, RoutedEventArgs e) {
            // maximise window - this must be on window load event to work properly
            WindowState = WindowState.Maximized;

           
        }

        public void SaveScreen() {

            Storyboard sbSaveScreenAnimation = (Storyboard)FindResource("sbSaveScreen");

            sbSaveScreenAnimation.Begin(this);

        }

#endregion

    }
}
