﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Configuration;

namespace WebScreenSaver
{

    /// <summary>
    /// Element class
    /// </summary>
    public class ScreenSetting : ConfigurationElement
    {

        [ConfigurationProperty("monitorNumber", IsRequired = true)]
        public Nullable<int> MonitorNumber
        {
            get
            {
                return this["monitorNumber"] as Nullable<int>;
            }
            set
            {
                this["monitorNumber"] = value;
            }
        }


        [ConfigurationProperty("location", IsRequired=true)]
        public string Location {
            get { 
                return this["location"] as string;
            }
            set {
                this["location"] = value;
            }
        }

        [ConfigurationProperty("refresh", IsRequired = true)]
        public Nullable<Boolean> Refresh
        {
            get
            {
                return this["refresh"] as Nullable<Boolean>;
            }
            set
            {
                this["refresh"] = value;
            }
        }

        [ConfigurationProperty("refreshIntervalInMinutes", IsRequired = true)]
        public Nullable<int> RefreshIntervalInMinutes
        {
            get
            {
                return this["refreshIntervalInMinutes"] as Nullable<int>;
            }
            set
            {
                this["refreshIntervalInMinutes"] = value;
            }
        }

    }

    /// <summary>
    /// Collection Class
    /// </summary>

    public class ScreenSettings : ConfigurationElementCollection
    {
        public ScreenSetting this[int index] {
            get {
                return base.BaseGet(index) as ScreenSetting;
            }
            set { 
                if (base.BaseGet(index) != null )
                {
                    base.BaseRemoveAt(index);
                }
                this.BaseAdd(index, value);
            }
        }

        protected override ConfigurationElement CreateNewElement()
        {
             return new ScreenSetting();
        }

        protected override object GetElementKey(ConfigurationElement element)
        {
            return ((ScreenSetting)element).MonitorNumber;
        }
    
    }

    public class ScreenConfiguration : ConfigurationSection
    {
        [ConfigurationProperty("screenSettings")]
        public ScreenSettings ScreenSettings {
            get {

                return this["screenSettings"] as ScreenSettings;
            }
        
        }

        public static ScreenConfiguration GetConfig()
        {
            return ConfigurationSettings.GetConfig("screenConfiguration") as ScreenConfiguration;
        }

    }


}
